//  yv122nv12.cpp
//
//	YV12 to NV12 converter
//
//	Copyright (c) 2004
//

#define WIN32_LEAN_AND_MEAN		// Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>

#include <streams.h>
#include <dvdmedia.h>
#include <aviriff.h> 
#include <initguid.h>
#include "yv122nv12.h"


extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}


//͂̃`FbN
HRESULT Cyv122nv12::CheckInputType(const CMediaType *mtIn)
{
    if (mtIn->majortype != MEDIATYPE_Video)
	{
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

    if (mtIn->subtype != MEDIASUBTYPE_YV12)
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	BITMAPINFOHEADER *pbmi;
	if (mtIn->formattype == FORMAT_VideoInfo && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &(((VIDEOINFOHEADER *)(mtIn->Format()))->bmiHeader);
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2)){
		pbmi = &(((VIDEOINFOHEADER2 *)(mtIn->Format()))->bmiHeader);
	}
	else{
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	if (pbmi->biCompression != FCC('YV12')){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}


    // ׂĖȂB
    return S_OK;
}

//o͌`̒
HRESULT Cyv122nv12::GetMediaType(int iPosition, CMediaType *pMediaType)
{
    ASSERT(m_pInput->IsConnected());
    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }
    if (iPosition == 0)
    {
        HRESULT hr = m_pInput->ConnectionMediaType(pMediaType);
        if (FAILED(hr))
        {
            return hr;
        }
        pMediaType->subtype = MEDIASUBTYPE_NV12;

		//BITMAPINFOHEADERł̃^Cvw
        BITMAPINFOHEADER *pbmi;
		if (pMediaType->formattype == FORMAT_VideoInfo && pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER))
		{
			pbmi = &((VIDEOINFOHEADER *)(pMediaType->Format()))->bmiHeader;
		}
		else if (pMediaType->formattype == FORMAT_VideoInfo2 && pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER2))
		{
			pbmi = &((VIDEOINFOHEADER2 *)(pMediaType->Format()))->bmiHeader;
		}
		else
		{
			return E_UNEXPECTED;
		}

		pbmi->biCompression = FCC('NV12');

        return S_OK;
    }
    // else
    return VFW_S_NO_MORE_ITEMS;
}

//ڑ̃`FbN
HRESULT Cyv122nv12::CheckTransform(
    const CMediaType *mtIn, const CMediaType *mtOut)
{

	BITMAPINFOHEADER *pbmiIn, *pbmiOut;
	RECT *prcSrc, *prcTarget;

	if (mtIn->formattype == FORMAT_VideoInfo && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pbmiIn = &((VIDEOINFOHEADER *)(mtIn->pbFormat))->bmiHeader;
		prcSrc = &((VIDEOINFOHEADER *)(mtIn->pbFormat))->rcSource;
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		pbmiIn = &((VIDEOINFOHEADER2 *)(mtIn->pbFormat))->bmiHeader;
		prcSrc = &((VIDEOINFOHEADER2 *)(mtIn->pbFormat))->rcSource;
	}else{
		return E_UNEXPECTED;
	}

	if (mtOut->formattype == FORMAT_VideoInfo && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmiOut   = &((VIDEOINFOHEADER *)(mtOut->Format()))->bmiHeader;
		prcTarget = &((VIDEOINFOHEADER *)(mtOut->Format()))->rcTarget;
	}
	else if (mtOut->formattype == FORMAT_VideoInfo2 && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER2)){
		pbmiOut   = &((VIDEOINFOHEADER2 *)(mtOut->Format()))->bmiHeader;
		prcTarget = &((VIDEOINFOHEADER2 *)(mtOut->Format()))->rcTarget;
	}else{
		return E_UNEXPECTED;
	}
	//biWidth̓XgCh̒l
	swOut = pbmiOut->biWidth;
	hOut = abs(pbmiOut->biHeight);
	swIn = pbmiIn->biWidth;
	hIn = abs(pbmiIn->biHeight);

	//قȂ邱Ƃ͂肦ȂEE
	if (hOut != hIn) {
		return VFW_E_INVALIDMEDIATYPE;
	}

	// ]`Ɠ]`rB
	// ܂Ӗ킩ĂȂB
    RECT rcImg;
	SetRect(&rcImg, 0, 0, swIn, hIn);
	if (IsRectEmpty(prcSrc) || EqualRect(prcSrc, &rcImg)) {
		// XgChlȂĂ悢ꍇ
		wIn = swIn;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcSrc->right;
		// ̓f[^̃XgChl
		if(!EqualRect(prcSrc, &rcImg2) || rcImg2.right>swIn) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		wIn = rcImg2.right;
	}
	SetRect(&rcImg, 0, 0, swOut, hOut);
	if (IsRectEmpty(prcTarget) || EqualRect(prcTarget, &rcImg)) {
		wOut = swOut;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcTarget->right;
		// o̓f[^̃XgChl
		if(!EqualRect(prcTarget, &rcImg2) || rcImg2.right>swOut) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		wOut = rcImg2.right;
	}

	// wOut,wIn͌󗘗pĂȂǁAꉞ`FbN
	if (wOut != wIn) {
		return VFW_E_INVALIDMEDIATYPE;
	}
	
    // ׂĖȂB
    return S_OK;
}

HRESULT Cyv122nv12::DecideBufferSize(
    IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp)
{
    AM_MEDIA_TYPE mt;
    HRESULT hr = m_pOutput->ConnectionMediaType(&mt);
    if (FAILED(hr))
    {
        return hr;
    }

    //BITMAPINFOHEADERTCY𓾂
    BITMAPINFOHEADER *pbmi;
	if (mt.formattype == FORMAT_VideoInfo && mt.cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &((VIDEOINFOHEADER *)(mt.pbFormat))->bmiHeader;
	} else if (mt.formattype == FORMAT_VideoInfo2 && mt.cbFormat >= sizeof(VIDEOINFOHEADER2)) {
		pbmi = &((VIDEOINFOHEADER2 *)(mt.pbFormat))->bmiHeader;
	} else {
		//ɂ͗Ȃ
		return E_UNEXPECTED;
	}
	//őH
    pProp->cbBuffer = DIBSIZE(*pbmi); 
    if (pProp->cbAlign == 0)
    {
        pProp->cbAlign = 1;
    }
    if (pProp->cBuffers == 0)
    {
        pProp->cBuffers = 1;
    }
    // tH[}bg ubNB
    FreeMediaType(mt);

    // AP[^ vpeBݒ肷B
    ALLOCATOR_PROPERTIES Actual;
    hr = pAlloc->SetProperties(pProp, &Actual);
    if (FAILED(hr)) 
    {
        return hr;
    }
    // ꍇAۂ̌ʂmFB
    if (pProp->cbBuffer > Actual.cbBuffer) 
    {
        return E_FAIL;
    }
    return S_OK;
}

//ۂ̕ϊ
HRESULT Cyv122nv12::Transform(IMediaSample *pSource, IMediaSample *pDest)
{
	// _EXg[̃tH[}bgύXB
    CMediaType *pMT = NULL;
    HRESULT hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
    if (hr == S_OK)
    {
        hr = m_pOutput->CheckMediaType(pMT);
        if(FAILED(hr))
        {
            DeleteMediaType(pMT);
            return E_FAIL;
        }
        // V^CvɂĎg̏o̓sɒʒmB
        m_pOutput->SetMediaType(pMT);
        DeleteMediaType(pMT);
    }

    // ɂȂobt@ւ̃|C^擾B
    BYTE *pBufferIn, *pBufferOut;
    hr = pSource->GetPointer(&pBufferIn);
    if (FAILED(hr))
    {
        return hr;
    }
    hr = pDest->GetPointer(&pBufferOut);
    if (FAILED(hr))
    {
        return hr;
    }
    // f[^B
	//CopyMemory(pBufferOut, pBufferIn, pSource->GetSize());
	//yv12_2_nv12(pBufferOut, pBufferIn, wIn, hIn);
	yv12_2_nv12a(pBufferOut, pBufferIn, swIn, hIn, swOut, swIn>swOut ? swOut:swIn);

	//ۂ̃f[^ʒm
	pDest->SetActualDataLength((swOut + ((swOut + 1) >> 1)) * hOut);
	//L[t[łB
    pDest->SetSyncPoint(TRUE);

    return S_OK;
}

//tB^̓o^
STDAPI DllRegisterServer(void)
{
    HRESULT hr = AMovieDllRegisterServer2(TRUE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->RegisterFilter(
            CLSID_YV122NV12,           // tB^ CLSIDB
            g_wszName,                       // tB^B
            NULL,                            // foCX jJB
            &CLSID_LegacyAmFilterCategory,   // Dsf
            NULL,                       // CX^X f[^B
            &rf2FilterReg                    // tB^B
            );
        pFM2->Release();
    }
    return hr;
}

//tB^̓o^
STDAPI DllUnregisterServer()
{
    HRESULT hr = AMovieDllRegisterServer2(FALSE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
            NULL, CLSID_YV122NV12);
        pFM2->Release();
    }
    return hr;
}


CUnknown *Cyv122nv12::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
    Cyv122nv12 *pFilter = new Cyv122nv12(NAME("YV12 to NV12 converter"), pUnk);
    if (pFilter== NULL) 
    {
        *pHr = E_OUTOFMEMORY;
    }
    return pFilter;
}

/*
 * YV12 -> NV12
 * XgChlver
 *
 * BYTE *pBufferOut : o̓obt@ւ̃|C^
 * BYTE *pBufferIn  : ̓obt@ւ̃|C^
 * LONG swIn        : ̓C[W̕(+XgCh)
 * LONG Height      : o̓C[W̍
 * LONG swOut       : o̓C[W̕(+XgCh)
 * LONG Width       : ۂɃRs[镝
 */
void yv12_2_nv12a(BYTE *pBufferOut, BYTE *pBufferIn, LONG swIn, LONG Height, LONG swOut, LONG Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	int hWidth = Width >> 1;
	int hHeight = Height >> 1;
	int offsYV = (swIn * Height)>> 2;
	BYTE *tmp_pBufferIn;
	BYTE *tmp_pBufferOut;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		CopyMemory(pBufferOut, pBufferIn, Width);
		pBufferOut += swOut;
		pBufferIn  += swIn;
	}
	
	tmp_pBufferOut = pBufferOut;
	tmp_pBufferIn  = pBufferIn;

	//UYC^[[uȂRs[
	for(i=0; i<hHeight; ++i) {
		for(j=0; j<hWidth; ++j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
		tmp_pBufferOut += swOut;
		tmp_pBufferIn  += swIn>>1;
		pBufferOut = tmp_pBufferOut;
		pBufferIn  = tmp_pBufferIn;
	}
	
}


/*
 * YV12 -> NV12
 * o[W
 */
void yv12_2_nv12(BYTE *pBufferOut, BYTE *pBufferIn, LONG imgWidth, LONG imgHeight)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	int hWidth = imgWidth >> 1;
	int hHeight = imgHeight >> 1;
	int offsY = imgWidth * imgHeight;
	int offsYV = offsY >> 2;

	//ỸRs[
	CopyMemory(pBufferOut, pBufferIn, offsY);
	
	pBufferOut += offsY;
	pBufferIn += offsY;

	for(i=0; i<hHeight; ++i) {
		for(j=0; j<hWidth; ++j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
	}
	
}
